#include <iostream>
#include <cstdint>

using namespace std;

const int MAXL = 1001;
int n, m, dp[MAXL][MAXL];
pair<int,int> from[MAXL][MAXL];
string s, t;

int main() {
    ios::sync_with_stdio(false);
    cin >> s >> t;
    n = s.length(), m = t.length();
    for (int i = 0; i <= n; ++i)
        for (int j = 0; j <= m; ++j)
            dp[i][j] = (i == 0 && j == 0) ? 0 : INT32_MAX;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i < n && j < m && s[i] == t[j]) {
                if (dp[i][j] + 1 < dp[i + 1][j + 1]) {
                    dp[i + 1][j + 1] = dp[i][j] + 1;
                    from[i + 1][j + 1] = {i, j};
                }
            }
            if (i < n) {
                if (dp[i][j] + 1 < dp[i + 1][j]) {
                    dp[i + 1][j] = dp[i][j] + 1;
                    from[i + 1][j] = {i, j};
                }
            }
            if (j < m) {
                if (dp[i][j] + 1 < dp[i][j + 1]) {
                    dp[i][j + 1] = dp[i][j] + 1;
                    from[i][j + 1] = {i, j};
                }
            }
        }
    }
    string ans(dp[n][m], '*');
    int i = n, j = m, p = dp[n][m] - 1;
    while (i > 0 || j > 0) {
        auto [pi, pj] = from[i][j];
        ans[p] = (pi < i) ? s[pi] : t[pj];
        i = pi, j = pj, --p;
    }
    cout << ans << endl;
    return 0;
}
